package cd.casic.ci.common.pipeline.pojo.element.market;

import cd.casic.ci.common.pipeline.pojo.element.Element;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.EqualsAndHashCode;

/**
 * @Author：mianbin
 * @Package：cd.casic.ci.common.pipeline.pojo.market
 * @Project：ops-pro
 * @name：AtomBuildArchiveElement
 * @Date：2025/03/26 17:31
 * @Filename：AtomBuildArchiveElement
 * @description：Todo
 */
@EqualsAndHashCode(callSuper = true)
@Schema(title = "插件发布归档", description = AtomBuildArchiveElement.CLASS_TYPE)
public class AtomBuildArchiveElement extends Element {
    public static final String CLASS_TYPE = "atomBuildArchive";

    @Schema(title = "任务名称", required = true)
    private String name = "插件发布归档";

    @Schema(title = "id", required = false)
    private String id;

    @Schema(title = "状态", required = false)
    private String status;

    @Schema(title = "插件发布包名称", required = true)
    private String packageName = "${packageName}";

    @Schema(title = "插件发布包所在相对路径", required = true)
    private String filePath = "${filePath}";

    @Schema(title = "插件发布包上传至仓库的目标路径", required = true)
    private String destPath = "${atomCode}/${version}/${packageName}";

    @Schema(title = "插件自定义UI前端文件所在相对路径", required = false)
    private String frontendFilePath = "${BK_CI_CUSTOM_FRONTEND_DIST_PATH}";

    @Schema(title = "插件自定义UI前端文件上传至仓库的目标路径", required = false)
    private String frontendDestPath = "${atomCode}/${version}";

    @Schema(title = "操作系统名称", required = false)
    private String osName = "${matrixOsName}";

    @Schema(title = "操作系统cpu架构", required = false)
    private String osArch = "${matrixOsArch}";

    @Schema(title = "是否有可用的操作系统名称配置", required = false)
    private String validOsNameFlag;

    @Schema(title = "是否有可用的操作系统cpu架构配置", required = false)
    private String validOsArchFlag;

    @Override
    public String getClassType() {
        return CLASS_TYPE;
    }
}
