package cd.casic.ci.common.pipeline.pojo.transfer;

import lombok.Data;

/**
 * @Author：mianbin
 * @Package：cd.casic.ci.common.pipeline.pojo.transfer
 * @Project：ops-pro
 * @name：RunAtomParam
 * @Date：2025/03/26 11:02
 * @Filename：RunAtomParam
 * @description：Todo
 */
@Data
public class RunAtomParam {
    private String shell;
    private String script;
    private CharsetType charsetType;

    public enum CharsetType {
        DEFAULT,
        UTF_8,
        GBK;

        public static CharsetType parse(String charset) {
            for (CharsetType type : values()) {
                if (type.name().equals(charset)) {
                    return type;
                }
            }
            return DEFAULT;
        }
    }


    public enum ShellType {
        BASH("bash"),
        CMD("cmd"),
        POWERSHELL_CORE("pwsh"),
        POWERSHELL_DESKTOP("powershell"),
        PYTHON("python"),
        SH("sh"),
        WIN_BASH("win_bash"),
        AUTO("auto");

        private final String shellName;

        ShellType(String shellName) {
            this.shellName = shellName;
        }
    }
}
