package cd.casic.pipeline.environment.pojo;

import cd.casic.pipeline.environment.pojo.enums.EnvType;
import cd.casic.pipeline.environment.pojo.enums.NodeSource;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.List;

@Getter
@AllArgsConstructor
@Schema(title = "环境信息")
public class EnvCreateInfo {
    @Schema(title = "环境名称", required = true)
    private final String name;

    @Schema(title = "环境描述", required = true)
    private final String desc;

    @Schema(title = "环境类型（开发环境{DEV}|测试环境{TEST}|构建环境{BUILD}）", required = true)
    private final EnvType envType;

    @Schema(title = "环境变量", required = false)
    private final List<EnvVar> envVars;

    @Schema(title = "节点来源（已有节点{EXISTING}|快速生成{CREATE}）", required = true)
    private final NodeSource source;

    @Schema(title = "节点 HashId 列表", required = false)
    private final List<String> nodeHashIds;
} 