package cd.casic.pipeline.environment.pojo.thirdpartyagent.pipeline;

import lombok.Getter;

@Getter
public enum PipelineStatus {
    PENDING(1),
    EXECUTING(2),
    TIMEOUT(3),
    FAILURE(4),
    SUCCESS(5);

    private final int status;

    PipelineStatus(int status) {
        this.status = status;
    }

    public static PipelineStatus from(int status) {
        for (PipelineStatus pipelineStatus : values()) {
            if (pipelineStatus.getStatus() == status) {
                return pipelineStatus;
            }
        }
        throw new RuntimeException("The pipeline status " + status + " is not exist");
    }
} 