package cd.casic.ci.process.command;

import cd.casic.framework.commons.util.watcher.Watcher;
import lombok.Data;

import java.util.Map;

/**
 * @author by mianbin
 * @Classname CmdContext
 * @Description 命令上下文基础类
 * @Date 2025/4/7 19:35
 */
@Data
public class CmdContext {
    protected int executeCount;
    protected int cmdFlowSeq;
    protected final Map<String, String> variables;
    protected final Watcher watcher;

    public CmdContext(int cmdFlowSeq, Map<String, String> variables, Watcher watcher) {
        this.cmdFlowSeq = cmdFlowSeq;
        this.executeCount = 1; // 对应 Kotlin 中的初始值
        this.variables = variables;
        this.watcher = watcher;
    }
}
