package cd.casic.ci.process.process.service.pipeline.impl;

import cd.casic.ci.common.pipeline.constant.PipelineDateUtilConstant;
import cd.casic.ci.common.pipeline.req.pipeline.PipelineReq;
import cd.casic.ci.common.pipeline.utils.PipelineDateUtil;
import cd.casic.ci.process.process.dal.pipeline.PipelineDao;
import cd.casic.ci.process.process.dataObject.pipeline.PipPipeline;
import cd.casic.ci.process.process.service.pipeline.PipelineService;
import cd.casic.framework.commons.util.object.BeanUtils;
import cd.casic.framework.commons.util.util.WebFrameworkUtils;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.util.Objects;

/**
 * @author HopeLi
 * @version v1.0
 * @ClassName PipelineServiceImpl
 * @Date: 2025/5/13 10:31
 * @Description:
 */
@Service
@Slf4j
public class PipelineServiceImpl extends ServiceImpl<PipelineDao, PipPipeline> implements PipelineService {
    @Override
    public String createPipeline(PipelineReq pipelineReq) {

        PipPipeline pipeline = new PipPipeline();
        BeanUtils.copyProperties(pipelineReq, pipeline);
        // 随机颜色
        int randomNumber = (int)(Math.random() * 5) + 1;
        pipeline.setColor(randomNumber);

        pipeline.setCreateTime(PipelineDateUtil.nowDateString(PipelineDateUtilConstant.yyyy_MM_dd_HH_mm_ss));
        if (Objects.isNull(pipeline.getUserId())){
            String loginUserId = String.valueOf(WebFrameworkUtils.getLoginUserId());
            pipeline.setUserId(loginUserId);
        }

        pipeline.setState(1);
        this.save(pipeline);

        //TODO 创建关联的流水线模板
        //TODO 创建对应的鉴权关系
        //TODO 创建对应的消息分发
        return pipeline.getId();
    }
}
