package cd.casic.ci.log.scm.enums;

import cd.casic.framework.commons.exception.ErrorCode;
import cd.casic.framework.commons.exception.ServiceException;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.commons.lang3.StringUtils;

import java.io.UnsupportedEncodingException;
import java.net.URLEncoder;

@AllArgsConstructor
@NoArgsConstructor
@Data
public class RepositoryConfig {

    private String repositoryHashId;

    private String repositoryName;

    private RepositoryType repositoryType;

    public String getRepositoryId() {
        if (repositoryType == RepositoryType.ID) {
            if (StringUtils.isEmpty(repositoryHashId)) {
                throw new ServiceException(new ErrorCode(-1000, "代码库HashId为空"));
            } else {
                return repositoryHashId;
            }
        } else if (repositoryType == RepositoryType.NAME) {
            if (StringUtils.isEmpty(repositoryName)) {
                throw new ServiceException(new ErrorCode(-1000, "代码库名为空"));
            } else {
                return repositoryName;
            }
        }
        return null;
    }

    public String getURLEncodeRepositoryId() {
        try {
            return URLEncoder.encode(getRepositoryId(), "UTF-8");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        return null;
    }

    @Override
    public String toString() {
        return "[repositoryHashId=" + repositoryHashId + ", repositoryName=" + repositoryName + ", repositoryType=" + repositoryType + "]";
    }
}
