package cd.casic.pipeline.store.pojo.common.approval;

import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

@Data
@Schema(title = "审核信息")
public class StoreApproveInfo {
    @Schema(title = "ID", required = true)
    private String approveId;
    @Schema(title = "审批内容", required = true)
    private String content;
    @Schema(title = "申请人", required = true)
    private String applicant;
    @Schema(title = "审批类型 ATOM_COLLABORATOR_APPLY:申请成为插件协作者", required = true)
    private String approveType;
    @Schema(title = "审批状态 WAIT:待审批，PASS:通过，REFUSE:拒绝", required = true)
    private String approveStatus;
    @Schema(title = "审批信息", required = false)
    private String approveMsg;
    @Schema(title = "store组件代码", required = true)
    private String storeCode;
    @Schema(title = "store组件类别 ATOM:插件 TEMPLATE:模板 IMAGE:镜像 IDE_ATOM:IDE插件", required = true)
    private String storeType;
    @Schema(title = "创建人", required = true)
    private String creator;
    @Schema(title = "修改人", required = true)
    private String modifier;
    @Schema(title = "创建日期", required = true)
    private Long createTime = 0L;
    @Schema(title = "更新日期", required = true)
    private Long updateTime = 0L;
}