package cd.casic.server.controller;

import cd.casic.ci.common.pipeline.req.stage.StageReq;
import cd.casic.ci.common.pipeline.resp.stage.StageResp;
import cd.casic.framework.commons.pojo.CommonResult;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;

import jakarta.annotation.security.PermitAll;
import jakarta.validation.Valid;
import jakarta.validation.constraints.NotNull;

import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;


import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * @pi.protocol: http
 * @pi.groupName: 流水线多阶段控制器
 */
@RestController
@RequestMapping("/stage")
public class StageController {

//    @Autowired
//    StageService stageService;

    /**
     * @pi.name:创建流水线阶段及任务
     * @pi.path:/stage/createStage
     * @pi.methodType:post
     * @pi.request-type:json
     * @pi.param: model=stage
     */
    @RequestMapping(path="/createStage",method = RequestMethod.POST)
    public CommonResult<String> createStagesOrTask(@RequestBody @Valid @NotNull StageReq stage){
//        String taskId = stageService.createStagesOrTask(stage);
        String taskId = "";
        return CommonResult.success(taskId);
    }

    /**
     * @pi.name:查询流水线阶段信息
     * @pi.path:/stage/finAllStage
     * @pi.methodType:post
     * @pi.request-type: formdata
     * @pi.param: name=pipelineId;dataType=string;value=pipelineId;
     */
    @PermitAll
    @RequestMapping(path="/finAllStage",method = RequestMethod.POST)
    public CommonResult<List<StageResp>> finAllPipelineTaskOrTask(@NotNull String pipelineId){
//        List<Stage> tasks = stageService.findAllStagesTask(pipelineId);
        String taskStr = "[\n" +
                "  {\n" +
                "    \"stageId\": \"36a816ca6cca\",\n" +
                "    \"stageName\": \"源码\",\n" +
                "    \"createTime\": \"2024-11-25 11:09:35\",\n" +
                "    \"pipelineId\": \"a69119cfbbde\",\n" +
                "    \"stageSort\": 1,\n" +
                "    \"parentId\": null,\n" +
                "    \"code\": true,\n" +
                "    \"taskValues\": null,\n" +
                "    \"stageList\": [\n" +
                "      {\n" +
                "        \"stageId\": \"8cde3a5616e9\",\n" +
                "        \"stageName\": \"源码\",\n" +
                "        \"createTime\": \"2024-11-25 11:09:35\",\n" +
                "        \"pipelineId\": null,\n" +
                "        \"stageSort\": 1,\n" +
                "        \"parentId\": \"36a816ca6cca\",\n" +
                "        \"code\": false,\n" +
                "        \"taskValues\": [\n" +
                "          {\n" +
                "            \"taskId\": \"a68e6052db9f\",\n" +
                "            \"createTime\": \"2024-11-25 11:09:35\",\n" +
                "            \"taskType\": \"git\",\n" +
                "            \"taskSort\": 1,\n" +
                "            \"taskName\": \"通用Git\",\n" +
                "            \"values\": null,\n" +
                "            \"pipelineId\": null,\n" +
                "            \"postprocessId\": null,\n" +
                "            \"stageId\": \"8cde3a5616e9\",\n" +
                "            \"task\": null,\n" +
                "            \"instanceId\": null\n" +
                "          }\n" +
                "        ],\n" +
                "        \"stageList\": null,\n" +
                "        \"taskType\": null,\n" +
                "        \"taskId\": null,\n" +
                "        \"values\": null,\n" +
                "        \"taskSort\": 0,\n" +
                "        \"parallelName\": null,\n" +
                "        \"instanceId\": null\n" +
                "      }\n" +
                "    ],\n" +
                "    \"taskType\": null,\n" +
                "    \"taskId\": null,\n" +
                "    \"values\": null,\n" +
                "    \"taskSort\": 0,\n" +
                "    \"parallelName\": null,\n" +
                "    \"instanceId\": null\n" +
                "  },\n" +
                "  {\n" +
                "    \"stageId\": \"3b1a5fdd9b6c\",\n" +
                "    \"stageName\": \"阶段-2\",\n" +
                "    \"createTime\": \"2025-03-10 14:51:43\",\n" +
                "    \"pipelineId\": \"a69119cfbbde\",\n" +
                "    \"stageSort\": 2,\n" +
                "    \"parentId\": null,\n" +
                "    \"code\": false,\n" +
                "    \"taskValues\": null,\n" +
                "    \"stageList\": [\n" +
                "      {\n" +
                "        \"stageId\": \"f35b1e576e30\",\n" +
                "        \"stageName\": \"并行阶段-2-1\",\n" +
                "        \"createTime\": \"2025-03-10 14:51:43\",\n" +
                "        \"pipelineId\": null,\n" +
                "        \"stageSort\": 1,\n" +
                "        \"parentId\": \"3b1a5fdd9b6c\",\n" +
                "        \"code\": false,\n" +
                "        \"taskValues\": [\n" +
                "          {\n" +
                "            \"taskId\": \"21a965370481\",\n" +
                "            \"createTime\": \"2025-03-10 14:51:43\",\n" +
                "            \"taskType\": \"maven\",\n" +
                "            \"taskSort\": 1,\n" +
                "            \"taskName\": \"Maven构建\",\n" +
                "            \"values\": null,\n" +
                "            \"pipelineId\": null,\n" +
                "            \"postprocessId\": null,\n" +
                "            \"stageId\": \"f35b1e576e30\",\n" +
                "            \"task\": null,\n" +
                "            \"instanceId\": null\n" +
                "          }\n" +
                "        ],\n" +
                "        \"stageList\": null,\n" +
                "        \"taskType\": null,\n" +
                "        \"taskId\": null,\n" +
                "        \"values\": null,\n" +
                "        \"taskSort\": 0,\n" +
                "        \"parallelName\": null,\n" +
                "        \"instanceId\": null\n" +
                "      }\n" +
                "    ],\n" +
                "    \"taskType\": null,\n" +
                "    \"taskId\": null,\n" +
                "    \"values\": null,\n" +
                "    \"taskSort\": 0,\n" +
                "    \"parallelName\": null,\n" +
                "    \"instanceId\": null\n" +
                "  },\n" +
                "  {\n" +
                "    \"stageId\": \"871c1b69efe0\",\n" +
                "    \"stageName\": \"阶段-3\",\n" +
                "    \"createTime\": \"2025-03-10 14:52:27\",\n" +
                "    \"pipelineId\": \"a69119cfbbde\",\n" +
                "    \"stageSort\": 3,\n" +
                "    \"parentId\": null,\n" +
                "    \"code\": false,\n" +
                "    \"taskValues\": null,\n" +
                "    \"stageList\": [\n" +
                "      {\n" +
                "        \"stageId\": \"63676c8428e6\",\n" +
                "        \"stageName\": \"并行阶段-3-1\",\n" +
                "        \"createTime\": \"2025-03-10 14:52:27\",\n" +
                "        \"pipelineId\": null,\n" +
                "        \"stageSort\": 1,\n" +
                "        \"parentId\": \"871c1b69efe0\",\n" +
                "        \"code\": false,\n" +
                "        \"taskValues\": [\n" +
                "          {\n" +
                "            \"taskId\": \"b5eaf0832ff1\",\n" +
                "            \"createTime\": \"2025-03-10 14:52:27\",\n" +
                "            \"taskType\": \"liunx\",\n" +
                "            \"taskSort\": 1,\n" +
                "            \"taskName\": \"主机部署\",\n" +
                "            \"values\": null,\n" +
                "            \"pipelineId\": null,\n" +
                "            \"postprocessId\": null,\n" +
                "            \"stageId\": \"63676c8428e6\",\n" +
                "            \"task\": null,\n" +
                "            \"instanceId\": null\n" +
                "          },\n" +
                "          {\n" +
                "            \"taskId\": \"cf756d646758\",\n" +
                "            \"createTime\": \"2025-05-10 14:17:52\",\n" +
                "            \"taskType\": \"script\",\n" +
                "            \"taskSort\": 2,\n" +
                "            \"taskName\": \"执行脚本\",\n" +
                "            \"values\": null,\n" +
                "            \"pipelineId\": null,\n" +
                "            \"postprocessId\": null,\n" +
                "            \"stageId\": \"63676c8428e6\",\n" +
                "            \"task\": null,\n" +
                "            \"instanceId\": null\n" +
                "          }\n" +
                "        ],\n" +
                "        \"stageList\": null,\n" +
                "        \"taskType\": null,\n" +
                "        \"taskId\": null,\n" +
                "        \"values\": null,\n" +
                "        \"taskSort\": 0,\n" +
                "        \"parallelName\": null,\n" +
                "        \"instanceId\": null\n" +
                "      },\n" +
                "      {\n" +
                "        \"stageId\": \"e9e4ac139f7b\",\n" +
                "        \"stageName\": \"并行阶段-3-2\",\n" +
                "        \"createTime\": \"2025-04-30 20:29:23\",\n" +
                "        \"pipelineId\": null,\n" +
                "        \"stageSort\": 2,\n" +
                "        \"parentId\": \"871c1b69efe0\",\n" +
                "        \"code\": false,\n" +
                "        \"taskValues\": [\n" +
                "          {\n" +
                "            \"taskId\": \"e46283a4b6d1\",\n" +
                "            \"createTime\": \"2025-04-30 20:29:23\",\n" +
                "            \"taskType\": \"script\",\n" +
                "            \"taskSort\": 1,\n" +
                "            \"taskName\": \"执行脚本\",\n" +
                "            \"values\": null,\n" +
                "            \"pipelineId\": null,\n" +
                "            \"postprocessId\": null,\n" +
                "            \"stageId\": \"e9e4ac139f7b\",\n" +
                "            \"task\": null,\n" +
                "            \"instanceId\": null\n" +
                "          },\n" +
                "          {\n" +
                "            \"taskId\": \"40740f834ce8\",\n" +
                "            \"createTime\": \"2025-05-10 14:17:17\",\n" +
                "            \"taskType\": \"script\",\n" +
                "            \"taskSort\": 2,\n" +
                "            \"taskName\": \"执行脚本\",\n" +
                "            \"values\": null,\n" +
                "            \"pipelineId\": null,\n" +
                "            \"postprocessId\": null,\n" +
                "            \"stageId\": \"e9e4ac139f7b\",\n" +
                "            \"task\": null,\n" +
                "            \"instanceId\": null\n" +
                "          }\n" +
                "        ],\n" +
                "        \"stageList\": null,\n" +
                "        \"taskType\": null,\n" +
                "        \"taskId\": null,\n" +
                "        \"values\": null,\n" +
                "        \"taskSort\": 0,\n" +
                "        \"parallelName\": null,\n" +
                "        \"instanceId\": null\n" +
                "      }\n" +
                "    ],\n" +
                "    \"taskType\": null,\n" +
                "    \"taskId\": null,\n" +
                "    \"values\": null,\n" +
                "    \"taskSort\": 0,\n" +
                "    \"parallelName\": null,\n" +
                "    \"instanceId\": null\n" +
                "  }\n" +
                "]";
        JSONArray objects = JSON.parseArray(taskStr);
        List<StageResp> tasks = new ArrayList<>(objects.size());
        for (int i = 0; i < objects.size(); i++) {
            StageResp object = objects.getObject(i, StageResp.class);
            tasks.add(object);
        }
        return CommonResult.success(tasks);
    }

    /**
     * @pi.name:更新流水线阶段任务
     * @pi.path:/stage/createStage
     * @pi.methodType:post
     * @pi.request-type:json
     * @pi.param: model=stage
     */
    @RequestMapping(path="/updateStage",method = RequestMethod.POST)
    public CommonResult<Void> updateStageTask(@RequestBody @Valid @NotNull StageReq stage){
//        stageService.updateStagesTask(stage);
        return CommonResult.success();
    }

    /**
     * @pi.name:更新流水线阶段名称
     * @pi.path:/stage/updateStageName
     * @pi.methodType:post
     * @pi.request-type:json
     * @pi.param: model=stage
     */
    @PermitAll
    @RequestMapping(path="/updateStageName",method = RequestMethod.POST)
    public CommonResult<Void> updateTasksStage(@RequestBody @Valid @NotNull StageReq stage){
//        stageService.updateStageName(stage);
        return CommonResult.success();
    }

    /**
     * @pi.name:删除流水线阶段及任务
     * @pi.path:/stage/deleteStage
     * @pi.methodType:post
     * @pi.request-type: formdata
     * @pi.param: name=taskId;dataType=string;value=taskId;
     */
    @RequestMapping(path="/deleteStage",method = RequestMethod.POST)
    public CommonResult<Void> deleteTasksOrStage(@NotNull String taskId){
//        stageService.deleteStagesOrTask(taskId);
        return CommonResult.success();
    }

    /**
     * @pi.name:效验流水线各个配置阶段完整性
     * @pi.path:/stage/validStagesMustField
     * @pi.methodType:post
     * @pi.request-type: formdata
     * @pi.param: name=pipelineId;dataType=string;value=流水线Id;
     */
    @RequestMapping(path="/validStagesMustField",method = RequestMethod.POST)
    public CommonResult<List<String>> validStagesMustField(@NotNull String pipelineId){
//        List<String> list = stageService.validStagesMustField(pipelineId);
//        return CommonResult.ok(list);
        return CommonResult.success(Collections.emptyList());
    }



}




























